(
global C2Editor
global MainNull
global filename
fn ReadValues tf=(filterstring (readline tf) " ")

fn multnum arg=
(
	arg=arg+"0000"
	a=findstring arg "."
	arg=replace arg a 1 ""
	a=a+4
	arg=replace arg a 0 "."
	arg=arg as float
)

fn divnum arg=
(
	arg=arg as string
	m=substring arg 1 1
	if m=="-" then
	(
		arg=substring arg 2 -1
	)else(
		m=""
	)
	arg="00"+arg
	a=findstring arg "."
	arg=replace arg a 1 ""
	a=a-2
	arg=replace arg a 0 "."
	if substring arg 1 5=="0000." then arg=replace arg 1 5 "0."
	if substring arg 1 4=="000." then arg=replace arg 1 4 "0."
	if substring arg 1 3=="00." then arg=replace arg 1 3 "0."
	if substring arg 1 4=="0000" then arg=replace arg 1 4 ""
	arg=m+arg
)

fn fGetValue tf=
(
	retval=undefined
	temp=ReadValues tf
	if temp.count<3 then
	(
		retval=temp[2]
	)else(
		x=temp[2] as float
		y=temp[3] as float
		z=temp[4] as float
		retval=[x,y,z]
	)
	return retval
)

fn getverts tf=
(
	vs=#()
	vc=(fGetValue tf) as integer
	if vc>0 then
	(for i=1 to vc do
	(
		temp=ReadValues tf
		x=multnum temp[2]
		y=multnum temp[4]
		z=multnum temp[3]
		append vs [-x,y,z]
	))
	return vs
)

fn getfaces tf =
(
	fs=#()
	fc=(fGetValue tf) as integer
	if fc>0 then
	(
		for i=1 to fc do
		(
			temp=ReadValues tf
			x=temp[2] as integer +1
			y=temp[3] as integer +1
			z=temp[4] as integer +1
			append fs [x,y,z]
		)
	)
	return fs
)

fn doC2mapping obj=
(
	gnam=""
	grp=#()
	if isgroupmember obj then
	(
		par=obj.parent
		gnam=par.name
		for i in par.children do append grp i
	)
	if getuserprop obj "Map"==undefined then setuserprop obj "Map" "Top"
	if getuserprop obj "Texture"==undefined then setuserprop obj "Texture" ""
	
	path=getfilenamepath filename
	tex=path + "TIFFRGB\\" + (getuserprop obj "Texture")+".tif"
	mm=standard()
	b=bitmaptex filename:(tex)
	mm.diffusemap=b
	showtexturemap mm mm.diffusemap on
	obj.material=mm
	
	map=getuserprop obj "Map"
	
	--rot=(quat 0 0 0 1)
	--if map=="Bottom" do rot=(quat 1 0 0 0)
	--if map=="Left" do rot=(quat 0.5 -0.5 0.5 -0.5)
	--if map=="Right" do rot=(quat 0.5 0.5 -0.5 -0.5)
	--if map=="Front" do rot=(quat 0 -0.707107 0.707107 0)
	--if map=="Back" do rot=(quat -0.707107 0 0 0.707107)
	
	--select obj
	--if subobjectlevel==undefined then max modify mode
	--subobjectlevel=0
	--addmodifier obj (uvwmap())
	
	mx=obj.max
	mn=obj.min
	extent=mx-mn
	center=mn+extent/2
	
	if map=="Top" then addmodifier obj (uvwmap axis:2 uflip:true)
	if map=="Bottom" then addmodifier obj (uvwmap axis:2 uflip:true)
	if map=="Front" then addmodifier obj (uvwmap axis:1)
	if map=="Back" then addmodifier obj (uvwmap axis:1 uflip:true)
	if map=="Left" then
	(
		select obj
		addmodifier obj (uvwmap axis:0)
		j=obj.modifiers[1]
		j.gizmo.rotation=(quat 0 -0.707107 0.707107 0)
		j.gizmo.position=center
		clearselection()
	)
	if map=="Right" then
	(
		select obj
		addmodifier obj (uvwmap axis:0)
		j=obj.modifiers[1]
		j.gizmo.rotation=(quat -0.707107 0 0 0.707107)
		j.gizmo.position=center
		clearselection()
	)
	converttomesh obj
	if gnam!="" then group grp name:gnam
)

fn MapObjs Direction=
(
	for obj in selection do
	(
		if superclassof obj==GeometryClass do
		(
			if subobjectlevel==undefined then max modify mode
			subobjectlevel=0
			setuserprop obj "Map" Direction
			doC2mapping obj
		)
	)
)

fn TexObjs tx=
(
	for obj in selection do
	(
		if superclassof obj==GeometryClass do
		(
			setuserprop obj "Texture" tx
			doC2mapping obj
		)
	)
)

fn updatetexturelist=
(
	tx=#()
	for i in geometry do
	(
		m=i.material
		if classof m==Standardmaterial then
		(
			if classof m.maps[2]==Bitmaptexture then
			(
				m=getfilenamefile (m.maps[2].filename)
				if m!="" and finditem tx m==0  then append tx (m)
			)
		)
	)
	sort tx
	try(C2EditorTextureRLT.texlist.items=tx)catch()
	return tx
)

fn FindReplace sString sFind sReplace=
(
	do(
		if (findstring sString sFind)!=undefined then sString=replace sString (findstring sString sFind) (sFind.count) sReplace
	)while (findstring sString sFind)!=undefined
	return sString
)

fn putverts obj tf=
(
	converttomesh obj
	format "Verts %\n" (getnumverts obj) to:tf
	for j=1 to getnumverts obj do
	(
		temp=getvert obj j
		x=divnum -temp.x
		y=divnum temp.z
		z=divnum temp.y
		format "Point % % %\n" x y z to:tf
	)
)

fn putfaces obj tf=
(
	converttomesh obj
	format "Faces %\n" (getnumfaces obj) to:tf
	for j=1 to getnumfaces obj do
	(
		temp=getface obj j
		format "Face % % %\n" (temp.x as integer-1) (temp.y as integer-1) (temp.z as integer-1) to:tf
	)
)

fn ExportC2obj=
(
	try(if isdeleted filename then filename="")catch(if filename==undefined then filename="")
	if filename=="" then
	(filename=getsavefilename "Save a C2 OBJ file" types:"Object File (*.obj)|*.obj")
	if filename != undefined then
	(
		fnam=getfilenamefile filename
		fpth=getfilenamepath filename
		tiff=fpth + "TIFFRGB\\"
		tex=#()
		gmt=#()
		
		for i in geometry do
		(
			append gmt i
			tx=""
			if classof i.material==Standardmaterial then
			(if classof i.material.maps[2]==Bitmaptexture then
			(tx=i.material.maps[2].filename))
			
			tnam=getfilenamefile tx
			tpth=getfilenamepath tx
			ttyp=getfilenametype tx
			ftna=tnam
			
			if ftna.count>15 then ftna=substring ftna 1 15
			FindReplace ftna " " "_"
			
			try(makedir tiff)catch()
			files=getfiles (tiff+ftna+ttyp)
			if files.count==0 then
			(
				copyfile (tpth+tnam+ttyp) (tiff+ftna+ttyp)
			)
			if finditem tex ftna==0 then append tex ftna
			mm=standard()
			mm.maps[2]=bitmaptexture()
			mm.maps[2].filename=(tiff+ftna+ttyp)
			showtexturemap mm mm.diffusemap on
			i.material=mm
			setuserprop i "Texture" ftna
		)
		tf=createfile (fpth+fnam+".OBJ")
		format "J3DOBJ1.10\n" to:tf
		format "ModelName %\n" MainNull.name to:tf
		format "Objects %\n" (geometry.count) to:tf
		for i in geometry do
		(
			tx=i.material.maps[2].filename
			tx=getfilenamefile tx
			tx=finditem tex tx
			format "Object %\n" (i.name) to:tf
			format "Texture %\n" tx to:tf
			format "Map %\n" (getuserprop i "Map") to:tf
			putverts i tf
			putfaces i tf
			format "<<End of Object>>\n" to:tf
		)
		grps=#()
		for i in helpers do (if isgrouphead i then append grps i)
		format "Groups %\n" grps.count to:tf
		primary=undefined
		for i in grps do
		(
			if i.name==(getuserprop MainNull "MainObject") then primary=i
		)
		if primary==undefined then (primary=grps[1])
		for i in grps do
		(
			t="False"
			if primary==i then t="True"
			s=i.name +" 0 "+t+" "
			for j in i.children do
			(
				s=s+ (-1+finditem gmt j) as string +" "
			)
			format "%\n" s to:tf
		)
		format "Textures %\n" tex.count to:tf
		for i in tex do
		(
			format "% %\n" i i to:tf
		)
		close tf
	)
)
global gmt
global grps
fn ImportC2obj fl= 
(
	filename=fl
	tf=openfile fl
	header=readline tf
	if header=="J3DOBJ1.10" then
	(
		if subobjectlevel==undefined then max modify mode
		subobjectlevel=0
		temp=fGetValue tf
		MainNull=dummy name:temp boxsize:[1000,1000,1000]
		objs=(fGetValue tf) as integer
		objects=#()
		for i=1 to objs do
		(
			onam=fGetValue tf
			otex=(fGetValue tf) as integer
			omap=fGetValue tf
			if omap=="undefined" then omap="Top"
			verts=getverts tf
			faces=getfaces tf
			eoo=readline tf
			if eoo=="<<End of Object>>" then
			(
				obj=mesh faces:faces vertices:verts name:onam
				obj.wirecolor=color 128 128 128
				addmodifier obj (smooth())
				converttomesh obj
				obj.parent=MainNull
				setuserprop obj "Map" omap
				setuserprop obj "Texture" otex
				append objects obj
			)
		)
		gc=(fGetValue tf) as integer
		groups=#()
		for i=1 to gc do
		(
			temp=readvalues tf
			append groups temp
		)
		tc=(fGetValue tf) as integer
		texs=#()
		for i=1 to tc do
		(
			temp=readvalues tf
			t=temp[2]
			append texs t
		)
		for i in objects do
		(
			temp=getuserprop i "Texture"
			if temp>0 then
			(
				setuserprop i "Texture" texs[temp]
			)else(
				setuserprop i "Texture" "" 
			)
			doC2mapping i
		)
		for i in groups do
		(
			if i.count>3 then
			(
				g=#()
				for j=4 to i.count do (append g objects[i[j] as integer +1])
				grouptemp=group g name:i[1]
				if i[3]=="True" then setuserprop MainNull "MainObject" i[1]
				grouptemp.parent=MainNull
			)
		)
	)
	close tf
)



rollout C2EditorRLT "C2 Editor"
(
	button filebutton "File" width:50 pos:[12,7]
	button objectbutton "Object" width:50 pos:[62,7]
	button texturebutton "Texture" width:50 pos:[112,7]
	
	on filebutton pressed do
	(
		C2EditorFileRLT.open=true
		C2EditorObjectRLT.open=false
		C2EditorTextureRLT.open=false
	)
	
	on objectbutton pressed do
	(
		C2EditorFileRLT.open=false
		C2EditorObjectRLT.open=true
		C2EditorTextureRLT.open=false
	)
	
	on texturebutton pressed do
	(
		C2EditorFileRLT.open=false
		C2EditorObjectRLT.open=false
		C2EditorTextureRLT.open=true
	)
)

rollout C2EditorFileRLT "File"
(
	button openobj "Open Obj" width:150
	label CurrentObjectLabel "None"
	button saveobj "Save Obj" width:150
	
	on openobj pressed do
	(
		filename=getopenfilename "Open a C2 OBJ file" types:"Object File (*.obj)|*.obj"
		if filename !=undefined then
		(
			importc2obj filename
			updatetexturelist()
		)
	)
	
	on saveobj pressed do
	(
		ExportC2obj()
	)
)

rollout C2EditorObjectRLT "Object"
(
	button makemain "Make Main" width:150
	button newobj "New Object" width:150
	button groupsel "Group Selection" width:150
	button makeprimary "Make Primary" width:150
	
	on makemain pressed do
	(
		if selection.count==0 then
		(
			obj=dummy name:"MainNull" boxsize:[1000,1000,1000]
			select obj
		)
		if selection.count>0 then
		(
			if classof selection[1]==Dummy then
			(if isgrouphead selection[1]==false then
			(if isgroupmember selection[1]==false then
			(
				MainNull=selection[1]
				MainNull.parent=undefined
				for i in geometry do
				(
					if isgroupmember i==false then i.parent=MainNull
				)
				for i in helpers do
				(
					if isgrouphead i==true then i.parent=MainNull
				)
			)))
			filename=undefined
		)
	)
	on newobj pressed do
	(
		newmain=false
		try(newmain=isdeleted MainNull)catch(newMain=MainNull==undefined)
		if newmain then
		(
			filename=getsavefilename "Please select a name for your file" types:"Object File (*.obj)|*.obj"
			if filename!=undefined then
			(
				MainNull=getfilenamefile filename
				MainNull=dummy name:MainNull boxsize:[1000,1000,1000]
			)
		)
		
		if filename!=undefined then
		(
			max select none
			max modify mode
			n=uniquename "Object"
			o=mesh vertices:#([0,0,0]) faces:#() name:n
			delete o.verts[1]
			o.wirecolor=(color 100 100 100)
			select o
			subobjectlevel=1
			meshops.startcreate (o)
		)
	)
	
	on makeprimary pressed do
	(
		a=selection[1]
		if isgrouphead a then
		(
			setuserprop MainNull "MainObject" a.name
		)
	)
)

rollout C2EditorTextureRLT "Texture"
(
	button map01 "Top" width:50 pos:[112,7]
	button map02 "Left" width:50 pos:[12,27]
	button map03 "Front" width:50 pos:[62,27]
	button map04 "Right" width:50 pos:[112,27]
	button map05 "Back" width:50 pos:[62,47]
	button map06 "Bottom" width:50 pos:[112,47]
	
	button loadtex "Load Texture" width:150
	listbox texlist height:10
	button updtlist "Update" width:150
	button reloadtex "Reload Texture" width:150
	
	on reloadtex pressed do
	(
		txnam=C2EditorTextureRLT.texlist.selected
		gmt=#()
		for i in geometry do
		(
			if getuserprop i "Texture"==txnam then
			(
				append gmt i
				mm=standard()
				i.material=mm
			)
		)
		freescenebitmaps()
		for obj in gmt do(doC2mapping obj)
	)
	
	on map01 pressed do(mapobjs "Top")
	on map02 pressed do(mapobjs "Left")
	on map03 pressed do(mapobjs "Front")
	on map04 pressed do(mapobjs "Right")
	on map05 pressed do(mapobjs "Back")
	on map06 pressed do(mapobjs "Bottom")
	
	on texlist doubleclicked arg do
	(
		TexObjs (C2EditorTextureRLT.texlist.items[arg])
	)
	on updtlist pressed do
	(
		tx=updatetexturelist()
		C2EditorTextureRLT.texlist.items=tx
	)
	on loadtex pressed do
	(
		f=getopenfilename "Open a Tif file" types:"Tiff Image (*.tif)|*.tif"
		if f !=undefined then
		(
			fnam=getfilenamefile f
			ftyp=getfilenametype f
			fpat=getfilenamepath f
			onam=fnam
			if onam.count>15 then onam=substring onam 1 15
			FindReplace onam " " "_"
			opth=getfilenamepath filename + "TIFFRGB\\"
			
			try(makedir opth)catch()
			copyfile (fpat+fnam+ftyp) (opth+onam+ftyp)
			tx=#()
			for i in C2EditorTextureRLT.texlist.items do
			(
				append tx i
			)
			if finditem tx fnam==0 then append tx fnam
			C2EditorTextureRLT.texlist.items=tx
		)
	)
)

rollout C2EditorPresetsRLT "Presets"
(
	listbox presetlist height:10
	button updatepresets "Update" width:150
	button addselected "Add Selected" width:150
	button removeselected "Remove Selected" width:150
	button appendselection "Append" width:150
	
	fn updatepre=
	(
		a=scriptspath + "C2Examples\\"
		b=getfiles (a+"*.asc")
		lst=#()
		for i in b do(append lst (getfilenamefile i))
		C2EditorPresetsRLT.presetlist.items=lst
	)
	
	fn putvalue arg1 arg2 tf=
	(
		if classof arg2==String then
			format "% %\n" arg1 arg2 to:tf
		if classof arg2==Integer then
			format "% %\n" arg1 arg2 to:tf
		if classof arg2==Point3 then
			format "% % % %\n" arg1 arg2.x arg2.y arg2.z to:tf
	)
	
	fn loadpreset fnam=
	(
		a=scriptspath + "C2Examples\\"+fnam+".asc"
		print a
		tf=openfile a
		n=(fGetValue tf)
		if n!=undefined then
		(
			vcount=(fGetValue tf) as integer
			fcount=(fGetValue tf) as integer
			v=#()
			f=#()
			for i=1 to vcount do (append v (fGetValue tf))
			for i=1 to fcount do (append f (fGetValue tf))
			close tf
			o=mesh vertices:v faces:f name:n
		)
	)
	
	fn savepreset b=
	(
		converttomesh b
		a=scriptspath + "C2Examples\\"+b.name+".asc"
		tf=createfile a
		putvalue "Name" b.name tf
		putvalue "Verts" (getnumverts b) tf
		putvalue "Faces" (getnumfaces b) tf
		for i=1 to (getnumverts b) do(putvalue "Vert" (getvert b i) tf)
		for i=1 to (getnumfaces b) do(putvalue "Face" (getface b i) tf)
		close tf
	)
	
	
	on updatepresets pressed do(updatepre())
	on presetlist doubleclicked arg do(loadpreset C2EditorPresetsRLT.presetlist.items[arg])
	on addselected pressed do
	(
		if C2EditorPresetsRLT.presetlist.selection!="" then
			loadpreset C2EditorPresetsRLT.presetlist.selected
	)
	on appendselection pressed do
	(
		if selection.count==1 then
		(
			b=selection[1]
			if superclassof b==GeometryClass then
				savepreset b
		)
		updatepre()
	)
	on removeselected pressed do
	(
		f=scriptspath + "C2Examples\\"+C2EditorPresetsRLT.presetlist.selected+".asc"
		print f
		if f!="" then print(deletefile f)
		updatepre()
	)
)


if C2Editor != undefined then closeRolloutFloater C2Editor

C2Editor=newrolloutfloater "C2 Editor" 200 450
addrollout C2EditorRLT C2Editor rolledup:false
addrollout C2EditorFileRLT C2Editor rolledup:false
addrollout C2EditorObjectRLT C2Editor rolledup:true
addrollout C2EditorTextureRLT C2Editor rolledup:true
addrollout C2EditorPresetsRLT C2Editor rolledup:true

)
